377. Combination Sum IV

Problem Statement

Given an array of distinct integers nums and a target integer target, return the number of possible combinations that add up to target.

The test cases are generated so that the answer can fit in a 32-bit integer.

Example 1:

Input: nums = [1,2,3], target = 4
Output: 7
Explanation:
The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)
Note that different sequences are counted as different combinations.

Example 2:

Input: nums = [9], target = 3
Output: 0

Constraints:

  • 1 <= nums.length <= 200

  • 1 <= nums[i] <= 1000

  • All the elements of nums are unique.

  • 1 <= target <= 1000

Follow up: What if negative numbers are allowed in the given array? How does it change the problem? What limitation we need to add to the question to allow negative numbers?

Intuition

Approach:

Start a for loop from start and go till the end, picking each element

Hence no need for tracking index

https://leetcode.com/problems/combination-sum-iv/description/?envType=daily-question&envId=2023-09-09

https://www.youtube.com/watch?v=IQeEhERcSbQ&t=402s&ab_channel=AryanMittal

Approach 1:

C++
class Solution {
public:
    vector<long long> dp; // Use long long instead of int
    long long find_comb(vector<int>& nums, int target) {
        if (target == 0)
            return 1;

        if (target < 0)
            return 0;

        if (dp[target] != -1)
            return dp[target];

        long long ans = 0; // Use long long
        for (int i = 0; i < nums.size(); i++)
            ans += find_comb(nums, target - nums[i]);

        return dp[target] = ans;
    }

    int combinationSum4(vector<int>& nums, int target) {
        dp = vector<long long>(target + 1, -1); // Adjust the size of the dp array
        return static_cast<int>(find_comb(nums, target)); // Convert the result to int
    }
};

Approach 2:

C++

Approach 3:

C++

Approach 4:

C++

Similar Problems

Last updated